<template>
	<footer :class="[$style.footer, showElement ? '' : $style.noForm]">
		<div v-if="subscribe && showElement" :class="$style.newsletter">
			<h5 v-if="subscribe.heading" class="u-font-secondary" :class="$style.newsletterHeading">
				{{ subscribe.heading }}
			</h5>

			<form v-if="!form.subscribed" @submit.prevent="submit">
				<div :class="$style.newsletterField">
					<FormInput
						v-model="form.email"
						label="Email:"
						:label-hidden="true"
						type="email"
						label-for="footer-email-input"
						placeholder="Enter your email"
						required
						:class="$style.newsletterInput"
						autocomplete="email"
						has-floating-label
					/>

					<BaseButton :class="$style.newsletterButton" type="submit" :is-working="form.submitted" size="medium">
						Subscribe
					</BaseButton>
				</div>
			</form>
			<div v-else role="alert" :class="$style.newsletterThankYou" v-html="subscribe.thankYou" />

			<p v-if="subscribe.subHeading" :class="$style.newsletterDesc">
				{{ subscribe.subHeading }}
			</p>
		</div>

		<div v-if="menus" :class="$style.menu">
			<ul v-for="(menu, menuIndex) in menus" :key="menuIndex" class="u-nolist" :class="$style.menuNav">
				<li>
					<h6 :class="$style.menuHeading">
						{{ menu.heading }}
					</h6>
				</li>
				<template v-if="menu.items && menu.items.length > 0">
					<li v-for="(item, itemIndex) in menu.items" :key="itemIndex" :class="$style.menuItem">
						<AtomDynamicLinkComponent v-bind="item.component" :class="$style.menuLink" @click="track(item.title)">
							{{ item.title }}
						</AtomDynamicLinkComponent>
					</li>
				</template>
			</ul>
		</div>

		<div v-if="socialLinks && socialLinks.length" :class="$style.social">
			<ul :class="$style.socialIcons">
				<li v-for="(item, itemIndex) in socialLinks" :key="itemIndex" :class="$style.icons">
					<component :is="item.link.element" v-bind="item.link.props">
						<BaseIcon :class="$style.socialListIcon" fill="#fff" :name="item.icon" :title="item.iconTitle" />
					</component>
				</li>
			</ul>
		</div>

		<div v-if="footer.text" v-rich-content :class="[$style.text, $style.desktop]" v-html="footer.text"></div>

		<div :class="$style.bottom">
			<ul v-if="links && links.length > 0" class="u-nolist" :class="[$style.bottomNav, $style.flexItem]">
				<li v-for="(item, index) in links" :key="index" :class="$style.bottomNavItem">
					<AtomDynamicLinkComponent v-bind="item.component" :class="$style.bottomNavLink" @click="track(item.title)">
						{{ item.title }}
					</AtomDynamicLinkComponent>
				</li>
			</ul>
			<nuxt-link :class="$style.logo" :to="{ name: 'index' }" @click.native="track('Molekule')">
				<BaseIcon id="logo2" fill="#fff" name="logo" title="Molekule" />
			</nuxt-link>

			<p :class="[$style.copyright, $style.flexItem]">&copy; {{ year }} Molekule. All rights reserved.</p>
		</div>

		<div v-if="footer.text" v-rich-content :class="[$style.text, $style.mobile]" v-html="footer.text"></div>
	</footer>
</template>

<script>
import { mapState } from 'vuex';
import FormInput from '@components/form-input';
import AtomDynamicLinkComponent from '@components/atom-dynamic-link-component';
import { prismicLinkToComponent } from '@/utils/prismic-helpers';

export default {
	components: {
		FormInput,
		AtomDynamicLinkComponent,
	},

	data: () => ({
		year: new Date().getFullYear(),
		form: {
			submitted: false,
			subscribed: false,
			email: '',
		},
	}),

	computed: {
		...mapState({ footer: (state) => state.globalData.footer }),

		subscribe() {
			return this.footer.subscribe;
		},

		menus() {
			return this.footer.menus.map((menu) => ({
				...menu.props,
				items: menu.props.items.map(this.mapPrismicMenuItem),
			}));
		},

		links() {
			return this.footer.links.map(this.mapPrismicMenuItem);
		},

		showElement() {
			const { subscribe } = this;
			if (!subscribe) return false;
			const { path } = this.$route;
			if (path === '/healthcare' || path === '/healthcare-inquiries') return false;
			return true;
		},

		socialLinks() {
			return this.footer.socialLinks.map((social) => ({
				...social,
				link: prismicLinkToComponent(social.iconLink),
			}));
		},
	},

	methods: {
		mapPrismicMenuItem(item) {
			return { component: prismicLinkToComponent(item.menuLink, item.newWindow), title: item.menuTitle };
		},

		submit() {
			// disable the submit button
			this.form.submitted = true;

			this.$axios
				.post('/custom-apis/subscribe', { email: this.form.email })
				.then((response) => {
					this.form.submitted = false;
					this.form.subscribed = true;

					const label = 'Footer';
					this.$tealiumEvent('email_signup', {
						event_category: 'Newsletter',
						event_action: 'Signed up for Newsletter',
						event_label: label,
						add_location: label,
						customer_email: this.form.email,
					});
				})
				.catch((error) => {
					this.form.submitted = false;
					console.error(error);
				});
		},

		track(name) {
			this.$tealiumEvent('footer_click', {
				event_category: 'Footer',
				event_action: 'Clicked Footer Navigation',
				event_label: name,
				footer_text: name,
			});
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.footer {
	padding: 4.8rem size('s') size('m');
	color: color('primary-600');
	background-color: color('primary-100');

	@include use-text-style('type-100');

	@include above('medium') {
		padding: 18.8rem size('s') size('l');
	}

	&.noForm {
		padding-top: size('l');
	}
}

// Newsletter
.newsletter {
	margin-bottom: size('m');

	@include above('xlarge') {
		margin-bottom: size('l');
	}
}

.newsletterHeading {
	margin: 0 auto 4.8rem;
	color: color('white');
	text-align: center;

	@include use-text-style('heading-600');

	@include above('medium') {
		max-width: none;
		font-size: 6rem;
	}
}

.newsletterDesc {
	margin: 4rem auto;
	text-align: center;

	@include above('medium') {
		margin-bottom: 16rem;
	}
}

.newsletterField {
	text-align: center;

	@include above('medium') {
		display: flex;
		justify-content: center;
	}
}

.newsletterInput {
	label {
		left: 2.5rem;
		color: color('white');
	}

	input[type='email']:not(.tw-input) {
		height: 4rem;
		padding: 0.9rem 2.5rem;
		margin-bottom: size('s');
		background-color: color('white');
		border-color: color('white');
		border-radius: 2rem;
		appearance: none;

		&:focus {
			outline: 0;
		}

		@include above('medium') {
			width: 35rem;
			height: 3.6rem;
			padding-top: 0.7rem;
			padding-bottom: 0.7rem;
			margin-right: 1rem;
			margin-bottom: 0;
		}
	}

	[class^='pseudoPlaceholder'] {
		top: 1.2rem;
		left: 2.6rem;

		@include above('medium') {
			top: 1.1rem;
		}
	}
}

.newsletterButton {
	height: 4rem;
	padding: 1.1rem 2.5rem;
	color: color('white');
	background-color: transparent;
	border: 1px solid color('white');
	border-radius: 2rem;

	@include use-text-style('type-100');

	@include above('medium') {
		height: 3.6rem;
		padding: 0.9rem 2.5rem;
	}

	&:hover,
	&:focus {
		color: color('text');
		background-color: color('white');
		outline: 0;
	}

	&:disabled {
		color: color('primary-200');
		background-color: color('button-disabled');
		border-color: color('button-disabled');
	}
}

.newsletterThankYou {
	display: flex;
	align-items: center;
	justify-content: center;
	height: 3.6rem;
	color: color('white');
	text-align: center;

	@include use-text-style('type');
	@include use-text-style('type-200');
}

// Main menu
.menu {
	display: flex;
	flex-wrap: wrap;
	justify-content: space-evenly;
	margin: 0 auto;

	@include above('small') {
		margin-right: size('xxs') * -1;
		margin-left: size('xxs') * -1;
	}

	@include above('medium') {
		flex-wrap: nowrap;
		margin: 0 size('l');
		border-top: 1px solid color('white');
	}
}

.menuNav {
	flex: 1 1 auto;
	width: (100% / 3);
	padding: size('xs') 0 0;
	margin-bottom: size('xs');
	border-top: 1px solid color('white');

	@include use-text-style('type-100');

	&:not(:nth-child(3n + 3)) {
		padding-right: size('m');
	}

	@include above('small') {
		flex: 1 1 auto;
		width: auto;
	}

	@include above('medium') {
		flex: 0 0 auto;
		border-top: 0;

		&:nth-child(3n + 3) {
			padding-right: size('m');
		}
	}
	&:last-child {
		@include above('small') {
			flex-grow: 0;
		}
	}
}

.menuHeading {
	margin-bottom: size('s');
	font-weight: 700;
}

.menuItem {
	margin-bottom: size('xxs');

	&:last-child {
		margin-bottom: 0;
	}
}

.menuLink {
	display: inline-block;
	color: color('primary-600');
}

.text {
	&.desktop {
		@include below('medium') {
			display: none;
		}

		display: flex;
		justify-content: center;
		margin-bottom: size('m');

		p {
			display: inline-block;
			padding: 0 5px;
		}
	}

	&.mobile {
		margin-bottom: size('xxs');
		color: color('white');

		@include above('medium') {
			display: none;
		}
	}

	a {
		color: inherit;
	}
}

// Bottom
.bottom {
	margin: 0 auto;

	@include use-text-style('type-100');

	@include above('medium') {
		display: flex;
		align-items: center;
		margin: 5.6rem size('l') 0;
		line-height: 1;
	}
	.copyright {
		margin-top: 2.4rem;
		text-align: center;

		@include above('medium') {
			margin-top: 0;
			margin-right: auto;
			text-align: left;
		}
	}
}

.flexItem {
	flex: 1 1;
}

.bottomNav {
	display: flex;
	flex-wrap: wrap;
	justify-content: flex-end;
	padding: size('xs') 0;
	margin: 0 0 size('m') auto;
	border: solid color('white');
	border-width: 1px 0;

	@include above('medium') {
		order: 3;
		padding: 0;
		margin-bottom: 0;
		border: 0;
	}
}

.bottomNavItem {
	display: block;
	flex: 0 0 auto;
	padding: 0 size('xxs') 0 0;
}

.bottomNavLink {
	color: inherit;
}

.logo {
	display: block;
	width: 10.9rem;
	height: 1.2rem;
	margin-bottom: size('xxs');

	@include above('medium') {
		order: 2;
		width: 10rem;
		height: 1.3rem;
		margin-bottom: 0;
	}
}

.social {
	display: flex;
	align-items: center;
	justify-content: center;
	margin: 2rem 0;
	overflow: hidden;

	@include above('medium') {
		margin: 2rem 6rem;
	}

	.socialIcons {
		position: relative;
		display: flex;
		align-items: center;
		list-style-type: none;

		&::before,
		&::after {
			position: absolute;
			top: 50%;
			width: 100vw;
			margin: 0 1rem;
			content: '';
			border-bottom: 1px solid color('white');

			@include above('medium') {
				margin: 0 6rem;
			}
		}

		&::before {
			right: 100%;
		}

		&::after {
			left: 100%;
		}
	}

	.icons {
		padding: 0 1.5rem;

		@include above('medium') {
			padding: 0 3rem;
		}
	}

	.socialListIcon {
		display: block;
		width: 2rem;
		height: 3rem;
	}
}
</style>
